# Class Vector3L

java.lang.Object
com.io7m.jtensors.core.unparameterized.vectors.Vector3L

All Implemented Interfaces:
  `Vector3LType, VectorReadable2LType, VectorReadable3LType, VectorComputationalType`

public final class Vector3L extends Object implements Vector3LType
The type of 3D `long`-typed vectors.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `Vector3L.Builder`
  Builds instances of type `Vector3L`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Vector3L.Builder`
  `builder()`
  Creates a builder for `Vector3L`.
  `static Vector3L`
  `copyOf(Vector3LType instance)`
  Creates an immutable copy of a `Vector3LType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `Vector3L` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x`, `y`, `z`.
  `static Vector3L`
  `of(long x, long y, long z)`
  Construct a new immutable `Vector3L` instance.
  `String`
  `toString()`
  Prints the immutable value `Vector3L` with attribute values.
  `final Vector3L`
  `withX(long value)`
  Copy the current immutable object by setting a value for the `x` attribute.
  `final Vector3L`
  `withY(long value)`
  Copy the current immutable object by setting a value for the `y` attribute.
  `final Vector3L`
  `withZ(long value)`
  Copy the current immutable object by setting a value for the `z` attribute.
  `long`
  `x()`
  `long`
  `y()`
  `long`
  `z()`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public long x()
    Specified by:
      `x` in interface `Vector3LType`
    Specified by:
      `x` in interface `VectorReadable2LType`
    Returns:
      The value of the `x` attribute

  - ### y

    public long y()
    Specified by:
      `y` in interface `Vector3LType`
    Specified by:
      `y` in interface `VectorReadable2LType`
    Returns:
      The value of the `y` attribute

  - ### z

    public long z()
    Specified by:
      `z` in interface `Vector3LType`
    Specified by:
      `z` in interface `VectorReadable3LType`
    Returns:
      The value of the `z` attribute

  - ### withX

    public final Vector3L withX(long value)
    Copy the current immutable object by setting a value for the `x` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy or the `this` object

  - ### withY

    public final Vector3L withY(long value)
    Copy the current immutable object by setting a value for the `y` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy or the `this` object

  - ### withZ

    public final Vector3L withZ(long value)
    Copy the current immutable object by setting a value for the `z` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for z
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `Vector3L` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`, `z`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `Vector3L` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static Vector3L of(long x, long y, long z)
    Construct a new immutable `Vector3L` instance.
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
      `z` - The value for the `z` attribute
    Returns:
      An immutable Vector3L instance

  - ### copyOf

    public static Vector3L copyOf(Vector3LType instance)
    Creates an immutable copy of a `Vector3LType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable Vector3L instance

  - ### builder

    public static Vector3L.Builder builder()
    Creates a builder for `Vector3L`.

        Vector3L.builder()
           .setX(long) // required x
           .setY(long) // required y
           .setZ(long) // required z
           .build();

    Returns:
      A new Vector3L builder